


#ifndef _NETVARS_H
#define _NETVARS_H


char TS_Server[32];
int TS_Port = 0;

char TS2_Server[32];
int TS2_Port = 0;

char ID[80];
char * EXEC_ID;

volatile int * exec_Action;
volatile int * exec_Signal;
char * exec_Parameter;
char * exec_Response;

volatile int * dacq_Trace;
volatile int * dacq_Alive;
volatile int * dacq_State;
volatile int * dacq_HistEnable;
volatile int * dacq_HistMode;
volatile int * dacq_SpectraMapped;

volatile int * dacq_TxInit;
volatile int * dacq_TxEnable;
volatile int * dacq_Tx2Enable;

volatile int * dacq_RdOutEnable;
volatile int * dacq_IgnoreNullEvents;

volatile int * dacq_TestMode;
volatile int * dacq_DebugMode1;
volatile int * dacq_DebugMode2;
volatile int * dacq_DebugMode3;
volatile int * dacq_DebugMode4;
volatile int * dacq_ReadOutOption;

volatile int * dacq_RawMode;

volatile int * dacq_PollTicks;
#define POLLTICKS 10                /*   default is not to Poll   */

volatile int * dacq_DelayTicks;
#define DELAYTICKS 200

int dacq_UseGroup = 0;   /*  flag to control event formatting in Eurogam option  */
int dacq_UseReadOutThreads = 0;   /* set non zero for SAGE thread operations */
volatile int * dacq_RunControl;  /*  set =1 to pause readout */

#define FORMAT_OPTION 3   /* event formatting   1=Exogam; 2=RISING/MBS; 3=Eurogam; 4=GREAT/RAW */
int Format_Option;

#define XFER_OPTION 3     /* transfer protocol  1=MIDAS (Ack); 3=MIDAS (NoAck); 4=RISING/MBS; 5=GANIL; 6=XDAQ (LNL) */
int Xfer_Option = 3;
int EBXfer_Option = 3;    /* no longer used */


int XferMode=3;
int EBXferMode=3;    /* no longer used */

int PushEnable = 0;
int FlushEnable = 0;
int Xfer_Priority = 0;
int Xfer_Overlap = 0;
int Xfer_BlockMode = 0;

volatile int * dacq_MultFactor;     /*  event is output this number of times - for data rate tests  */

#define TDC_OPTION 3  /* 1=first value; 2=last value; 3=all values  */
int TDC_Option = 3;

#define TDC_MODE 1;
int TDC_Mode = 1;        /*  1=normal;  2 common stop;  3 common start */

int TDC_Reference = 0;         /*  0 -> 127  common stop/start using channel n */

char ScratchNetString[80];    /* temporary value  */
int ScratchNetInt;

#define NETBLOCKLENGTH 4000

#endif
