

#ifdef USETHREADS
void xfer_event(int, int);
void xfer_block(int);
void insert_block_header(int);
void insert_block_trailer(int);
#else
void xfer_event(int);
void xfer_block(int);
void insert_block_header();
void insert_block_trailer();
#endif

void xfer_push(int);

typedef struct mbs_subevent_header {
    unsigned long mbs_dlen;
    unsigned short mbs_subtype;
    unsigned short mbs_type;
    char mbs_control;
    char mbs_subcrate;
    unsigned short mbs_procid;
} MBS_HEADER;


#define MBS_SubSysID 0x0100

int Block_Sequence_Number = 0;
int Block_Event_Count = 0;

int xfer_pushDisable = 0;
int xfer_pushRequired = 0;    /*  used by PUSH logic between Heartbeat thread and main thread */

int ExogamOutputBufferLen;                     /* in units of short */
unsigned short * ExogamCurrentOutputBuffer;
