

    int chEnergy=0;         /*  channel energy  */
    long long chTime=0;
    long long chExtTime;
    int chPU=0;
    int chID=0;

void  febex_formatJLdata() {
  
/*    check the incoming data format and convert to TDR  output format     */

  
    int i;
    int rc;
    
    unsigned int * itembuffer;
    int dataitem;
    
    int chTS1500, chTS3116, chTS4732, chTS5548, chTS6356=0;   /*  channel timestamp  */
    int chUE1500, chUE3116;                                   /*  channel unsigned energy  */
    

    int len;
    int items;
    
    uint32_t   Data32;
    
/*   generates output data for the histogramming in evntbuffer * eventbufferlen  
     input data is in units of 6 (16 bit) words  writting by the firmware into the sum channel buffer  */
 
    evntbuffer = (unsigned int *) EventBufferAddr;     /* output data  */
    evntbufferlen = 0;

    sigtrapset ("Error formatting data buffer");
    
/*    receives input data from febex_readevent in databuffer & databufferlen  */
    
		
        itembuffer = &databuffer[0];
	len =  databufferlen;
	
if(*dacq_Trace > 1)printf("MWD 0x%x %d \n",*itembuffer, len);

        Stats[COUNT0] = Stats[COUNT0] + len;

lab1:

        while (len > 0)
	{
	  
	   dataitem = *itembuffer++;
	   len--;
	   
if(*dacq_Trace > 3) printf("1 0x%x %d \n",dataitem, len);

	   if ((dataitem & 0xff000034) != 0xff000034) {printf ("error 1 %d\n",items); Stats[COUNT1]++; goto lab1;}
	   
	   if ((dataitem & 0xff000034) == 0xff000034) {   /*  valid sum channel header */
	     
	     modID = (dataitem >> 16) & 15;
	     sfpID = (dataitem >> 12) & 3;
	     trigID = (dataitem >> 8) & 15;
	     
	     Stats[SUMHDR]++;
	     Stats[(sfpID * MAX_SLAVE) + SUMHDR]++;
	    
	     items = *itembuffer++/4;       /*  length in 32 bit words  */
             len--;

             if (items < 2 || items > (DMASIZE/4)) {printf ("error 2 %d\n",items); Stats[COUNT2]++;  goto lab1;}

	     
if(*dacq_Trace > 2)printf("2 0x%x %d %d\n",dataitem, len, items);
	     
// 
	     
	     for (i=0; i<items; i+=3) {
	     
if(*dacq_Trace > 2)printf("3.0 0x%x %d %d\n",*itembuffer, len, items);


            if (((*itembuffer >> 25) & 7) != 0) {printf ("error 3 0x%x\n", *itembuffer); Stats[COUNT3]++; len--; goto lab1;}
	      
	       chID = (*itembuffer >> 28) & 15;
	       chPU = (*itembuffer >> 24) & 1;
	       chTS5548 = (*itembuffer >> 16) & 0x00ff;
	       chTS4732 = *itembuffer & 0x0ffff;
	       itembuffer++;
              
	       
	       chTS3116 = (*itembuffer >> 16) & 0x0ffff;
	       chTS1500 = *itembuffer & 0x0ffff;
	       itembuffer++;
	       
	       chUE3116 = (*itembuffer >> 16) & 0x0ffff;
	       chUE1500 = *itembuffer & 0x0ffff;
	       itembuffer++;
	       
	       chEnergy = (chUE3116 << 16) | chUE1500;
	       chTime = ((unsigned long long)chTS5548 << 48) | ((unsigned long long)chTS4732 << 32) | ((unsigned long long)chTS3116 << 16) | (unsigned long long)chTS1500;
	      
if(*dacq_Trace > 2)printf("3.1 %d %d %d 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x\n",len, chID, chPU, chTS5548, chTS4732, chTS3116, chTS1500, chUE3116, chUE1500);
if(*dacq_Trace > 2)printf("3.2 %d %d 0x%lx 0x%llx\n",len, chID, chEnergy, chTime);
	     
	       len-= 3;

                /*    generate output data in TDR format    */
		/*    evntbuffer and evntbufferlen  define a buffer of ints for the TDR format data passed back to interrupt.c */
		
		Data32 = (3 << 30) | (chPU << 29) | (sfpID << 26) | (modID << 22) | (0 << 20) | (chID << 16) | ((int)chUE1500 & 0x0ffff);   /* channel energy word bits 0 => 15  */
		
if(*dacq_Trace > 2)printf ("6.0 0x%x\n", Data32);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = chTime; 
		evntbufferlen++;

		Data32 = (3 << 30) | (chPU << 29) | (sfpID << 26) | (modID << 22) | (1 << 20) | (chID << 16) | ((int)chUE3116 & 0x0ffff);   /* channel energy word bits 16 => 32  */
		
if(*dacq_Trace > 2)printf ("6.1 0x%x\n", Data32);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = chTime;
		evntbufferlen++;

                chExtTime = (unsigned int) ((chTime >> 32) & 0x0ffff);

		Data32 = (3 << 30) | (chPU << 29) | (sfpID << 26) | (modID << 22) | (2 << 20) | (chID << 16) | ((int)chExtTime & 0x0ffff);   /* timestamp bits 28 => 44  */
		
if(*dacq_Trace > 2)printf ("6.2 0x%x\n", Data32);

                *evntbuffer++ = Data32;
		evntbufferlen++;
		*evntbuffer++ = chTime;
		evntbufferlen++;

	     }      /*  end of       for (i=0; i<items; i+=3) */


	  }  /*  end of   if ((dataitem & 0xff000034) == 0xff000034) {      sum channel  header   */
	     

          EventBufferLen =  evntbufferlen;   /* for the histogrammer code  */
		  
if(*dacq_Trace > 1)printf ("8 End of  FEBEX readevent %d\n", EventBufferLen);	  
	
        }  /*  end of   while (len > 0)  */

if(*dacq_Trace > 1)printf ("9 End of  FEBEX readevent %d\n", EventBufferLen);
    
    sigtrapset ("Error detected during data acquisition");

// sleep (1000);

    return;

}



